VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IniFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'------------------------------------------------------------------------------
'
'   ACTvZT[rX TvvO
'   INIt@CNX
'
'   Copyrights (c) 2004-2005 Advanced Core Technologies, Inc. All rights reserved.
'
'   2005/03/04 Rev.1.00 RIN J
'
'------------------------------------------------------------------------------

Option Explicit

'------------------------------------------------------------------------------
'   Win32 API
'------------------------------------------------------------------------------

'   [Private]

'   ANSI GetPrivateProfileString
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" ( _
    ByVal lpszSectionName As String, _
    ByVal lpszKeyName As String, _
    ByVal lpszDefault As String, _
    ByVal lpszReturnedString As String, _
    ByVal nSize As Long, _
    ByVal lpszFileName As String) As Long
'   ANSI GetPrivateProfileInt
Private Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" ( _
    ByVal lpszSectionName As String, _
    ByVal lpszKeyName As String, _
    ByVal nDefault As Long, _
    ByVal lpszFileName As String) As Long
'   ANSI WritePrivateProfileString
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" ( _
    ByVal lpszSectionName As String, _
    ByVal lpszKeyName As String, _
    ByVal lpszString As String, _
    ByVal lpszFileName As String) As Long

'------------------------------------------------------------------------------
'   Constants
'------------------------------------------------------------------------------

'   [Private]
    
Private Const DIRECTORY_SEPARATOR As String = "\"   '   fBNgԂ̋؂L
Private Const EXTENTION_SIGNATURE As String = "."   '   gq̎ʕ
Private Const EXTENTION_INIFILE As String = ".ini"  '   INIt@C̊gq
Private Const BUFFER_LENGTH_MAX As Long = 260 + 1   '   obt@񒷂̍ől

'------------------------------------------------------------------------------
'   Members
'------------------------------------------------------------------------------

'   [Private]

Private m_AppPath As String                         '   AvP[VtH_pX
Private m_FileName As String                        '   INIt@C

'------------------------------------------------------------------------------
'   Methods
'------------------------------------------------------------------------------

'   [Public]

'   INIt@C̎w肵ZNṼL[當擾
'   p[^
'       lpszSectionName [IN]ZNV
'       lpszKeyName     [IN]L[
'       lpszDefault     [IN]INIt@C݂ȂꍇɕԂl
'   ߂l
'       w肵L[̕(Ggꍇ)
'       lpszDefault         (GgȂꍇ)
Public Function GetProfileString(ByVal lpszSectionName As String, ByVal lpszKeyName As String, ByVal lpszDefault As String) As String
    Dim lpszReturnedString As String
    
    If m_AppPath = "" Then
        m_AppPath = App.Path    '   AvP[VtH_pX̐ݒ
    End If
    If m_FileName = "" Then
        m_FileName = App.EXEName + EXTENTION_INIFILE    '   INIt@C̐ݒ
    End If

    lpszReturnedString = String$(BUFFER_LENGTH_MAX, vbNullChar)

    GetPrivateProfileString lpszSectionName, lpszKeyName, lpszDefault, lpszReturnedString, _
    Len(lpszReturnedString), m_AppPath + DIRECTORY_SEPARATOR + m_FileName
    
    lpszReturnedString = Left$(lpszReturnedString, InStr(1, lpszReturnedString, vbNullChar & vbNullChar) - 1)

    GetProfileString = lpszReturnedString
End Function

'   INIt@C̎w肵ZNṼL[琔l擾
'   p[^
'       lpszSectionName [IN]ZNV
'       lpszKeyName     [IN]L[
'       lpszDefault     [IN]INIt@C݂ȂꍇɕԂl
'   ߂l
'       w肵L[̐l  (Ggꍇ)
'       nDefault            (GgȂꍇ)
'       0                   (GgɑΉlłȂꍇ)
Public Function GetProfileInt(ByVal lpszSectionName As String, ByVal lpszKeyName As String, ByVal nDefault As Long) As Long
    If m_AppPath = "" Then
        m_AppPath = App.Path    '   AvP[VtH_pX̐ݒ
    End If
    If m_FileName = "" Then
        m_FileName = App.EXEName + EXTENTION_INIFILE    '   INIt@C̐ݒ
    End If
        
    GetProfileInt = GetPrivateProfileInt(lpszSectionName, lpszKeyName, nDefault, _
    m_AppPath + DIRECTORY_SEPARATOR + m_FileName)
End Function

'   INIt@C̎w肵ZNṼL[ɕݒ肷
'   p[^
'       lpszSectionName [IN]ZNV
'       lpszKeyName     [IN]L[
'       lpszString      [IN]ݒ肷镶
'   ߂l
'       0ȊO   ̐ݒɐ
'       0       ̐ݒɎs
Public Function WriteProfileString(ByVal lpszSectionName As String, ByVal lpszKeyName As String, ByVal lpszString As String) As Long
    Dim lpszWriteString As String
    
    If m_AppPath = "" Then
        m_AppPath = App.Path    '   AvP[VtH_pX̐ݒ
    End If
    If m_FileName = "" Then
        m_FileName = App.EXEName + EXTENTION_INIFILE    '   INIt@C̐ݒ
    End If
    
    lpszWriteString = RTrim(lpszString)
    
    WriteProfileString = WritePrivateProfileString(lpszSectionName, lpszKeyName, lpszWriteString, _
    m_AppPath + DIRECTORY_SEPARATOR + m_FileName)
End Function

'   INIt@C̎w肵ZNṼL[ɐlݒ肷
'   p[^
'       lpszSectionName [IN]ZNV
'       lpszKeyName     [IN]L[
'       nValue          [IN]ݒ肷鐔l
'   ߂l
'       0ȊO   l̐ݒɐ
'       0       l̐ݒɎs
Public Function WriteProfileInt(ByVal lpszSectionName As String, ByVal lpszKeyName As String, ByVal nValue As Long) As Long
    If m_AppPath = "" Then
        m_AppPath = App.Path    '   AvP[VtH_pX̐ݒ
    End If
    If m_FileName = "" Then
        m_FileName = App.EXEName + EXTENTION_INIFILE    '   INIt@C̐ݒ
    End If
    
    WriteProfileInt = WritePrivateProfileString(lpszSectionName, lpszKeyName, CStr(nValue), _
    m_AppPath + DIRECTORY_SEPARATOR + m_FileName)
End Function

'   INIt@Cݒ(ύX)
'   p[^
'       lpszFileName [IN]INIt@C
'   ߂l
'       Ȃ
Public Sub SetFileName(ByVal lpszFileName As String)
    m_FileName = lpszFileName
End Sub

'   AvP[VtH_pXݒ(ύX)
'   p[^
'       lpszAppPath [IN]AvP[VtH_pX
'   ߂l
'       Ȃ
Public Sub SetAppPath(ByVal lpszAppPath As String)
    m_AppPath = lpszAppPath
End Sub

'   End of Source

